Since libpng-1.4, jmpbuf is no longer directly accessible, and we need
the macro png_jmpbuf. We also define this macro for older versions of
libpng.

--- png/pngwrite.c.orig	2012-02-27 15:54:56.000000000 +0100
+++ png/pngwrite.c	2012-02-27 15:55:27.000000000 +0100
@@ -15,6 +15,9 @@
 
 #if HAVE_PNG
 #include <png.h>
+#ifndef png_jmpbuf
+#define png_jmpbuf(ptr) ptr->jmpbuf
+#endif
 #endif
 
 #include <caml/mlvalues.h>
@@ -57,7 +60,7 @@
   }
 
   /* error handling */
-  if (setjmp(png_ptr->jmpbuf)) {
+  if (setjmp(png_jmpbuf(png_ptr))) {
     /* Free all of the memory associated with the png_ptr and info_ptr */
     png_destroy_write_struct(&png_ptr, &info_ptr);
     fclose(fp);
@@ -166,7 +169,7 @@
   }
 
   /* error handling */
-  if (setjmp(png_ptr->jmpbuf)) {
+  if (setjmp(png_jmpbuf(png_ptr))) {
     /* Free all of the memory associated with the png_ptr and info_ptr */
     png_destroy_write_struct(&png_ptr, &info_ptr);
     fclose(fp);
